



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>最长绝对文件路径——算法面试刷题1（google），字符串处理，使用tree遍历dfs类似思路</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">最长绝对文件路径——算法面试刷题1（google），字符串处理，使用tree遍历dfs类似思路</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 15:20:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>假设我们通过以下的方式用字符串来抽象我们的文件系统：<br />
字符串<code>"dir\n\tsubdir1\n\tsubdir2\n\t\tfile.ext"</code>代表了：</p>
<pre class="prettyprint linenums"><code>dir<br />
	subdir1<br />
	subdir2<br />
		file.ext<br />
</code></pre>
<p>目录 <code>dir</code> 包含一个空子目录 <code>subdir1</code> 和一个包含文件file.ext的子目录 <code>subdir2</code>。<br />
字符串</p>
<pre class="prettyprint linenums"><code>"dir\n\tsubdir1\n\t\tfile1.ext\n\t\tsubsubdir1\n\tsubdir2\n\t\tsubsubdir2\n\t\t\tfile2.ext"<br />
</code></pre>
<p>代表了：</p>
<pre class="prettyprint linenums"><code>dir<br />
	subdir1<br />
		file1.ext<br />
		subsubdir1<br />
	subdir2<br />
		subsubdir2<br />
			file2.ext<br />
</code></pre>
<p>目录 <code>dir</code> 包含两个子目录 <code>subdir1</code> 和 <code>subdir2</code> 。 <code>subdir1</code> 包含一个文件 file1.ext 和一个空的二级子目录 <code>subsubdir1</code> 。 <code>subdir2</code> 包含一个包含文件 file2.ext 的二级子目录 <code>subsubdir2</code>。<br />
我们有兴趣找到文件系统中文件的最长绝对路径（字符数）。例如，在上面的第二个例子中，最长的绝对路径是<code>&ldquo;dir/subdir2/subsubdir2/file2.ext&rdquo;</code>，其长度为 <code>32</code> (不包括双引号)。<br />
给定一个以上述格式表示文件系统的字符串，返回抽象文件系统中文件最长绝对路径的长度。如果系统中没有文件，则返回 <code>0</code> 。</p>
</div>
</div>
<div>&nbsp;</div>
<div>
<div>
<div>
<ul><li>一个文件的名称至少包含一个 <code>.</code> 和扩展名。</li>
<li>目录或子目录的名称不会包含 <code>.</code> 。</li>
<li>时间复杂度要求： <code>O(n)</code> 其中 n 是输入字符串的大小。</li>
<li>请注意如果有另一条路径 <code>aaaaaaaaaaaaaaaaaaaaa / sth.png</code> 存在的话, <code>a/aa/aaa/file1.txt</code> 不是最长的文件路径。---这个东西巨坑！！！以为是树的最长路径，结果还不是！！！。&nbsp;&nbsp; ****我写的代码：
<div>
<div>
<pre class="prettyprint linenums">class Solution:<br />
    """<br />
    @param input: an abstract file system<br />
    @return: return the length of the longest absolute path to file<br />
    """<br />
    def lengthLongestPath(self, input):<br />
        # write your code here<br />
        ans = 0<br />
        path = []<br />
        lines = input.split("\n")<br />
        for line in lines:<br />
            cnt = self.count_tab(line)<br />
            path_name = self.get_path_name(line)<br />
            if cnt &lt; len(path):<br />
                path[cnt] = path_name<br />
            else:<br />
                path.append(path_name)<br />
            if self.is_file(path_name):<br />
                length = len("/".join(path[:cnt+1]))<br />
                if length &gt; ans: ans = length<br />
        return ans

    def count_tab(self, s):<br />
        return s.count("\t")

    def get_path_name(self, s):<br />
        index = s.rfind("\t")<br />
        if index &gt;= 0:<br />
            return s[index+1:] # +2 is error. \t is a char!!!<br />
        else:<br />
            return s

    def is_file(self, f):<br />
        return f.find(".") &gt;= 0
</pre>
</div>
<p>参考代码：</p>
<div>
<pre class="prettyprint linenums">import re

class Solution:<br />
    # @param {string} input an abstract file system<br />
    # @return {int} return the length of the longest absolute path to file<br />
    def lengthLongestPath(self, input):<br />
        # Write your code here<br />
        dict = collections.defaultdict(lambda: "")<br />
        lines = input.split("\n")

        n = len(lines)<br />
        result = 0<br />
        for i in xrange(n):<br />
            count = lines[i].count("\t")

            lines[i] = dict[count - 1] + re.sub("\\t+","/", lines[i])<br />
            if "." in lines[i]:<br />
                result = max(result, len(lines[i]))<br />
            dict[count] = lines[i]

        return result
</pre>
</div>
<p>值得借鉴的地方：</p>
<p>1、re.sub() 替换连续\t为/</p>
<p>2、使用dict来存储路径长度</p>
</div></li></ul>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e04djq.html">简单的STM32 汇编程序&mdash;闪烁LED</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96mvdy8.html">【JAVA】Runtime</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93d6ww8.html">C&num;如何实现下载文件保存到本地上面去</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwed7zq.html">&lbrack;c&num;&rsqb;params可变参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pr12zq.html">IEE数据库kill指定条件的进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xndkz9.html">&lbrack;JavaEE&rsqb; 深入理解Struts2的ognl标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgx1oq.html">C&num; 按指定数量从前面或者后面删除字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xe2on9.html">伪元素&rdquo;&colon;after&rdquo; &comma; &OpenCurlyDoubleQuote;&colon;before&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkok508.html">unittest单元测试框架总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzkgl8.html">php intval（）和floatval&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgyl48.html">AJAX面试题都在这里</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgrk6d8.html">听晴明老师从头讲React Native（原价399）百度云下载 百度网盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zllnj9.html">Python基础之面向对象思维解决游戏《天龙八部》</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyny1m9.html">SpringBoot前后端分离Instant时间戳自定义解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1ken459.html">&lbrack;译&rsqb;Ocelot - Claims Transformation</a>
		</li>
						<li><a href="https://www.batexi.com/a/960mdyn9.html">linux重装系统，如何保存硬盘中的内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj54g09.html">C&num;中&num;region和&num;endregion的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1r7d5q.html">one-hot句子向量   对比度增强</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lpmwq.html">Python3基础 dict 推导式 生成10以内&plus;奇数的值为True 偶数为False的字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpez5e9.html">详细解读Android中的搜索框（二）&mdash;&mdash; Search Dialog</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kp3ykr9.html">Linux基础命令---sar显示系统活动信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eypngm9.html">qt手写输入法资料</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzyw5g8.html">【winform】splitContainer拆分器控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzyyl08.html">第十二节 JS事件高级应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvkkkk8.html">ios开发蓝图</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv255pj9.html">IDEA中Git的更新、提交、还原方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvkk138.html">UML类图新手入门级介绍（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwndx48.html">word模板导出的几种方式：第三种：标签替换（DocX组件读取与写入Word）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2me72q.html">hello2代码的简单分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyw1jjq.html">Vue学习&mdash;&mdash;学习vue必须了解的几个知识点</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
